Add testcases for 'git log --diff-filter=[CM]' (copies and renames).
Also add a testcase for 'git log --follow'.Signed-off-by: Arjen Laarhoven <arjen@yaph.org>
---
t/t4202-log.sh | 59 +++++++++++++++++++++++++++++++++++++++++++++++--------
1 files changed, 50 insertions(+), 9 deletions(-)diff --git a/t/t4202-log.sh b/t/t4202-log.sh
index 0ab925c..7b976ee 100755
--- a/t/t4202-log.sh
+++ b/t/t4202-log.sh
@@ -16,27 +16,31 @@ test_expect_success setup '
test_tick &&
git commit -m second &&- mkdir a &&
- echo ni >a/two &&
- git add a/two &&
+ git mv one ichi &&
test_tick &&
git commit -m third &&- echo san >a/three &&
- git add a/three &&
+ cp ichi ein &&
+ git add ein &&
test_tick &&
git commit -m fourth &&- git rm a/three &&
+ mkdir a &&
+ echo ni >a/two &&
+ git add a/two &&
+ test_tick &&
+ git commit -m fifth &&
+
+ git rm a/two &&
test_tick &&
- git commit -m fifth
+ git commit -m sixth'
test_expect_success 'diff-filter=A' '
actual=$(git log --pretty="format:%s" --diff-filter=A HEAD) &&
- expect=$(echo fourth ; echo third ; echo initial) &&
+ expect=$(echo fifth ; echo fourth ; echo third ; echo initial) &&
test "$actual" = "$expect" || {
echo Oops
echo "Actual: $actual"
@@ -60,7 +64,43 @@ test_expect_success 'diff-filter=M' '
test_expect_success 'diff-filter=D' 'actual=$(git log --pretty="format:%s" --diff-filter=D HEAD) &&
- expect=$(echo fifth) &&
+ expect=$(echo sixth ; echo third) &&
+ test "$actual" = "$expect" || {
+ echo Oops
+ echo "Actual: $actual"
+ false
+ }
+
+'
+
+test_expect_success 'diff-filter=R' '
+
+ actual=$(git log -M --pretty="format:%s" --diff-filter=R HEAD) &&
+ expect=$(echo third) &&
+ test "$actual" = "$expe...
When the '--follow' option is used with '--find-copies-harder' ('-C -C')
logs on individual files will work across file copies as well as
renames.Intermediate copies will not be shown as a result of the workings of the
'--find-copies-harder' option.Signed-off-by: Arjen Laarhoven <arjen@yaph.org>
---
Documentation/git-log.txt | 6 +++++-
t/t4202-log.sh | 12 ++++++++++++
tree-diff.c | 2 ++
3 files changed, 19 insertions(+), 1 deletions(-)diff --git a/Documentation/git-log.txt b/Documentation/git-log.txt
index 34cf4e5..2d42101 100644
--- a/Documentation/git-log.txt
+++ b/Documentation/git-log.txt
@@ -52,7 +52,11 @@ include::diff-options.txt[]
commits, and doesn't limit diff for those commits.--follow::
- Continue listing the history of a file beyond renames.
+ Continue listing the history of a file beyond renames. When
+ combined with `--find-copies-harder` (`-C -C`) git will also
+ list the file history beyond copies. Intermediate copies
+ will be skipped, e.g. a copy of file A to B to C will not
+ show B when showing the log on file C.--log-size::
Before the log message print out its size in bytes. Intended
diff --git a/t/t4202-log.sh b/t/t4202-log.sh
index 7b976ee..a8dd690 100755
--- a/t/t4202-log.sh
+++ b/t/t4202-log.sh
@@ -109,6 +109,18 @@ test_expect_success 'git log --follow' ''
+test_expect_success 'git log --follow --find-copies-harder' '
+
+ actual=$(git log --follow -C -C --pretty="format:%s" ein) &&
+ expect=$(echo fourth; echo third ; echo second ; echo initial) &&
+ test "$actual" = "$expect" || {
+ echo Oops
+ echo "Actual: $actual"
+ false
+ }
+
+'
+
test_expect_success 'setup case sensitivity tests' '
echo case >one &&
test_tick &&
diff --git a/tree-diff.c b/tree-diff.c
index 9f67af6..73652b2 100644
--- a/tree-diff.c
+++ b/tree-diff.c
@@ -333,6 +333,8 @@ static void try_to_follow_renames(struct tree_desc *t1, struct tree_desc *t2, co...
| Paul Jackson | Re: cpuset-remove-sched-domain-hooks-from-cpusets |
| Chuck Ebbert | Why do so many machines need "noapic"? |
| Bart Van Assche | Integration of SCST in the mainstream Linux kernel |
| Linus Torvalds | Linux 2.6.21 |
| Jonathan Gray | CVS: cvs.openbsd.org: src |
| Claudio Jeker | CVS: cvs.openbsd.org: src |
| Tobias Stoeckmann | CVS: cvs.openbsd.org: src |
| Otto Moerbeek | CVS: cvs.openbsd.org: src |
| Andrea Arcangeli | missing kvm smp tlb flush in invlpg |
| Zhang, Xiantao | RE: [PATCH] qemu-kvm: Flush icache after dma operations for ia64 |
| sudhir kumar | kvm-autotest: The automation plans? |
| Joerg Roedel | [PATCH 0/3] KVM SoftMMU fixes |
| Justin Mattock | Re: [19.666764] Disabling IRQ #23 |
| Oliver Neukum | Re: Autosuspend and interrupt-context output |
| David Vrabel | New subsystems: Ultra-Wideband radio, Wireless USB and WiMedia LLC Protocol |
| Felipe Balbi | g_file_storage and buggy scsi implementaions |
